#include "filters.h"

float box_filter(float x, float r){
	if(-r <= x || x < r){
		return 1.0/(2.0*r);
	} else {
		return 0;
	}
}

float tent_filter(float x){
	x = abs(x);
	if(x < 1.0){
		return 1.0 - x;
	} else {
		return 0;
	}
}

float tentr_filter(float x, float r){
	return (tent_filter(x/r))/r;
} 

float bspline_filter(float x, float r){
	x = 2*abs(x)/r;
	float val;

	if(x < 1){
		val = -3*pow(1 - x, 3) + 3*pow(1 - x, 2) + 3*(1 - x) + 1;
	} else if(x <= 2){
		val = pow(2 - x, 3);
	} else {
		val = 0;
	}
	val /= (3 * r);
	return val;
}