#ifndef _GRAPHICS_
#define _GRAPHICS_

#include <math.h>
#include <stdio.h>
#include <iostream>
using namespace std;
#include "libtarga.h"
#include "TargaImage.h"

const double PI		= 3.14159265358979323846;
const double PID2	= 1.57079632679489661923;
																																																		const float l = 2.0;

int pos(int x, int y, int num_col);
int c_pos(int x, int y, int rad);
unsigned char* getPixel(TargaImage* image, int x, int y);
void copy_pxl(unsigned char* src, unsigned char* dest);

//reduce
TargaImage* resize(TargaImage* image, int new_width, int new_height, float(*filter)(float x, float r));
void resample_horz(TargaImage* image, TargaImage* new_image, float(*filter)(float x, float r));
void resample_vert(TargaImage* image, TargaImage* new_image, float(*filter)(float x, float r));

//dithering
void FS_dither_pxl(TargaImage* image, int x, int y, float* d_matrix, int d_size);
TargaImage* bw(TargaImage* image);
TargaImage* greyscale(TargaImage* image);

//impressionist
TargaImage* impress(TargaImage* image, int brush);

//warping
double normalize(int x, int max);
int denormalize(double x, int max);
void warp0_pxl(TargaImage* image, int* x, int* y);
void warp1_pxl(TargaImage* image, int* x, int* y);
void warp2_pxl(TargaImage* image, int* x, int* y);
TargaImage* warp(TargaImage* image, void(*transform)(TargaImage*, int*, int*), int option);

#endif